import * as S from './index.js';
declare type Unnest<T> = T extends Array<any> ? T[number] : never;
declare type Store<T> = {
    sample(): T;
    sampleAll(): T[];
    read(): T;
    readAll(): T[];
    write(f: (row: T) => T): void;
    getReadStream: () => S.Computation<T[]>;
    focus<U>(get: (row: T) => U[] | [], set: (state: T, update: ((row: U) => U)) => T): Store<U>;
    prop<K extends keyof T>(key: K): Store<T[K]>;
    unnest: () => Store<Unnest<T>>;
    filter(f: ((row: T) => boolean)): Store<T>;
    path: string[];
};
export declare function createStore<T>(name: string, table: T[]): Store<T>;
export { root } from './index.js';
